<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFamiliasERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFamiliasERP
 * @subpackage Arrays
 */
class ArrayOfFamiliasERP extends AbstractStructArrayBase
{
    /**
     * The FamiliasERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FamiliasERP[]
     */
    public $FamiliasERP;
    /**
     * Constructor method for ArrayOfFamiliasERP
     * @uses ArrayOfFamiliasERP::setFamiliasERP()
     * @param \StructType\FamiliasERP[] $familiasERP
     */
    public function __construct(array $familiasERP = array())
    {
        $this
            ->setFamiliasERP($familiasERP);
    }
    /**
     * Get FamiliasERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FamiliasERP[]|null
     */
    public function getFamiliasERP()
    {
        return isset($this->FamiliasERP) ? $this->FamiliasERP : null;
    }
    /**
     * Set FamiliasERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FamiliasERP[] $familiasERP
     * @return \ArrayType\ArrayOfFamiliasERP
     */
    public function setFamiliasERP(array $familiasERP = array())
    {
        foreach ($familiasERP as $arrayOfFamiliasERPFamiliasERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfFamiliasERPFamiliasERPItem instanceof \StructType\FamiliasERP) {
                throw new \InvalidArgumentException(sprintf('The FamiliasERP property can only contain items of \StructType\FamiliasERP, "%s" given', is_object($arrayOfFamiliasERPFamiliasERPItem) ? get_class($arrayOfFamiliasERPFamiliasERPItem) : gettype($arrayOfFamiliasERPFamiliasERPItem)), __LINE__);
            }
        }
        if (is_null($familiasERP) || (is_array($familiasERP) && empty($familiasERP))) {
            unset($this->FamiliasERP);
        } else {
            $this->FamiliasERP = $familiasERP;
        }
        return $this;
    }
    /**
     * Add item to FamiliasERP value
     * @throws \InvalidArgumentException
     * @param \StructType\FamiliasERP $item
     * @return \ArrayType\ArrayOfFamiliasERP
     */
    public function addToFamiliasERP(\StructType\FamiliasERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FamiliasERP) {
            throw new \InvalidArgumentException(sprintf('The FamiliasERP property can only contain items of \StructType\FamiliasERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FamiliasERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FamiliasERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FamiliasERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FamiliasERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FamiliasERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FamiliasERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FamiliasERP
     */
    public function getAttributeName()
    {
        return 'FamiliasERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfFamiliasERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
